/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_PelvisAndUterusAnatomicSites;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_PelvisAndUterusAnatomicSites;
import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.BreastGYNMammoSNOMEDMap;

/**
 * This class represents PelvisAndUterusAnatomicSites CID12023
 */
public class PelvisAndUterusAnatomicSites_CID12023 {

	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * Instantiates a new PelvisAndUterusAnatomicSites_CID12023 Template 
	 */
	public PelvisAndUterusAnatomicSites_CID12023()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumPelvisAndUterusAnatomicSites Object of EnumCM_PelvisAndUterusAnatomicSites represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_PelvisAndUterusAnatomicSites enumPelvisAndUterusAnatomicSites)
	{
		switch(enumPelvisAndUterusAnatomicSites) 
		{
		case CERVIX: this.strCodeValue =EnumCV_PelvisAndUterusAnatomicSites.CERVIX_T_83200.getValue(); break;
		case ENDOMETRIUM: this.strCodeValue =EnumCV_PelvisAndUterusAnatomicSites.ENDOMETRIUM_T_83400.getValue(); break;
		case UTERUS: this.strCodeValue =EnumCV_PelvisAndUterusAnatomicSites.UTERUS_T_83000.getValue(); break;
		}
	}

	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumPelvisAndUterusAnatomicSites Object of EnumCM_PelvisAndUterusAnatomicSites represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_PelvisAndUterusAnatomicSites enumPelvisAndUterusAnatomicSites)
	{
		switch(enumPelvisAndUterusAnatomicSites)
		{
		case CERVIX : this.strSNOMEDCTID =BreastGYNMammoSNOMEDMap.CERVIX.getSNOMEDCTID(); break;
		case ENDOMETRIUM : this.strSNOMEDCTID =BreastGYNMammoSNOMEDMap.ENDOMETRIUM.getSNOMEDCTID(); break;
		case UTERUS : this.strSNOMEDCTID =BreastGYNMammoSNOMEDMap.UTERUS.getSNOMEDCTID(); break;
		}
	}

	/**
	 * Sets the value for PelvisAndUterusAnatomicSites
	 * @param enumPelvisAndUterusAnatomicSites Object of EnumCM_PelvisAndUterusAnatomicSites.
	 */
	public void setPelvisAndUterusAnatomicSites(EnumCM_PelvisAndUterusAnatomicSites enumPelvisAndUterusAnatomicSites)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumPelvisAndUterusAnatomicSites.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumPelvisAndUterusAnatomicSites);

		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumPelvisAndUterusAnatomicSites);
	}
}
